#include <string.h>
#include "setiview.h"

extern WINDOW *analysis;

static char status_string[128]="Starting up...";
static char drift_string[128]="";
static char shift_string[128]="";
static char fftlen_string[128]="";

static void draw_analysis(int line, const char *string)
{
	wmove(analysis, line, 0);
	wclrtoeol(analysis);
	waddstring(analysis, string, A_NORMAL);
}

void analysis_redraw(void)
{
	const char *analysis_title = "Data Analysis";

	wmove(analysis, 0, (COLS/2 - strlen(analysis_title))/2);
	waddstring(analysis, analysis_title, A_BOLD);

	draw_analysis(1, status_string);
	draw_analysis(2, drift_string);
	draw_analysis(3, shift_string);
	draw_analysis(4, fftlen_string);

	wnoutrefresh(analysis);
}

void analysis_status(const char *stat)
{
	strncpy(status_string, stat, 128);
	draw_analysis(1, status_string);
	setiview_refresh(analysis);
}

void analysis_drift(const char *drift)
{
	sprintf(drift_string, "Doppler drift rate: %s", drift);
	draw_analysis(2, drift_string);
	setiview_refresh(analysis);
}

void analysis_shift(const char *shift)
{
	sprintf(shift_string, "Doppler shift rate: %s", shift);
	draw_analysis(3, shift_string);
	setiview_refresh(analysis);
}

void analysis_fftlen(const char *length)
{
	sprintf(fftlen_string, "FFT length: %s", length);
	draw_analysis(4, fftlen_string);
	setiview_refresh(analysis);
}

