#include <stdlib.h>
#include "conf.h"

conf_struct *conf_open(const char *fname)
{
	FILE *fp;
	conf_struct *cs;

	fp = fopen(fname, "r");
	if(!fp) return NULL;
	
	cs = (conf_struct*) malloc(sizeof(conf_struct));
	cs->fp = fp;

	return cs;
}

int do_conf_scan(conf_struct *cs, const char *ibuf, void *dest)
{
	char buf[128];
	if(!cs) return 0;
	rewind(cs->fp);
	while(!feof(cs->fp)) {
		fgets(buf, 128, cs->fp);
		if(sscanf(buf, ibuf, dest)) return 1;
	}
	return 0;
}

int conf_get_string(conf_struct *cs, const char *parm, char *dest)
{
	char ibuf[128];
	sprintf(ibuf, "%.124s=%%s", parm);
	return do_conf_scan(cs, ibuf, (void*)dest);
}

int conf_get_float(conf_struct *cs, const char *parm, float *dest)
{
	char ibuf[128];
	sprintf(ibuf, "%.124s=%%f", parm);
	return do_conf_scan(cs, ibuf, (void*)dest);
}

int conf_get_int(conf_struct *cs, const char *parm, int *dest)
{
	char ibuf[128];
	sprintf(ibuf, "%.124s=%%d", parm);
	return do_conf_scan(cs, ibuf, (void*)dest);
}

void conf_close(conf_struct *cs)
{
	fclose(cs->fp);
	free(cs);
}

