%{
#include "setiview.h"

#define YY_INPUT(buf,result,max_size) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		result = n; \
		} \

static void parse_fft(const char *text)
{
	char shift[128];
	int i=0;
	while(*text && *text != ',') shift[i++] = *text++;
	shift[i]=0;
	analysis_shift(shift);
	while(*text && (*text < '0' || *text > '9')) text++;
	analysis_fftlen(text);
	analysis_status("Computing Fast Fourier Transform");
}

/* woo.  hacky hacky.  */
extern int interrupted;
int yywrap(void) { if(interrupted) return 1; seti_restart(); return 0; }
%}

%%
^"Logged in as ".*$						{ user_info_login(yytext+13); }
^"Number of work units processed: ".*$				{ user_info_workunits(atoi(yytext+32)); }
^"Total CPU time: ".*$						{ user_info_cputime((int)atof(yytext+16)); }

^"Doppler shifting data by ".*$					{ analysis_drift(yytext+25); }
^"Starting work for Doppler shift rate ".*$			{ parse_fft(yytext+37); }
^"Starting Analysis of Power over Time (curve fitting)".*$	{ analysis_status("Gaussian curve-fitting"); }
^"... Searching for Gaussians".*$				{ analysis_status("Searching for Gaussians"); }
^"... Searching for Pulses".*$					{ analysis_status("Searching for Pulses"); }
^"Doing baseline smoothing".*$					{ analysis_status("Doing baseline smoothing"); }
^"Chirping data".*$						{ analysis_status("Chirping data"); }
^"Done with work unit".*$					{ user_info_workunit_complete(); }

^"Data Info:".*$			{ progress_clear(); }
^"Sky coord".*$				{ data_info_put(0, yytext); }
^"Recorded on".*$			{ data_info_put(1, yytext); }
^"Source".*$				{ data_info_put(2, yytext); }
^"Base Freq".*$				{ data_info_put(3, yytext); }

^.*"connecting to server".*$		{ analysis_status(yytext); progress_clear(); }
^"Sending data: ".*$			{ progress_send(atoi(yytext+14)); }
^"Receiving data: ".*$			{ progress_receive(atoi(yytext+16)); }
^.*"% done".*$				{ progress_done(atof(yytext)); }

^"Unknown error".*$			{ analysis_status(yytext); }
^"Can't connect".*$			{ analysis_status(yytext); }
"Bad file header"			{ analysis_status(yytext); }

.|\n					{ misc_put(yytext[0]); }

%%

