#include "setiview.h"
#include <sys/stat.h>
#include <unistd.h>

WINDOW *progress;

static char label[128]="";
int status_width, status_complete;

void draw_bar(void)
{
	int i;
	int hline, box;

	/* check for broken curses which would normally just draw crap */
	if(ACS_HLINE) {
		hline = ACS_HLINE;
		box = ' '|A_REVERSE;
	} else {
		hline = '-';
		box = '#';
	}

	wmove(progress, 0, 1);
	wclrtoeol(progress);
	waddstring(progress, label, A_NORMAL);
	wmove(progress, 0, COLS - status_width-1);

	if(status_complete > status_width) status_complete = status_width;

	for(i=0;i<status_complete;i++) waddch(progress, box);
	for(;i<status_width;i++) waddch(progress, hline);
}

void progress_redraw(void)
{
	status_width = COLS - 10;

	wclear(progress);
	if(label[0]) draw_bar();
	wnoutrefresh(progress);
}

static int outfile_txt_size(void)
{
	struct stat buf;
	int k;
	if(stat("outfile.sah", &buf)) return 30;
	/* round up to 10k increments */
	k = (buf.st_size+10239)/10240;
	return k*10;
}

#define round(k) ((int)(k+0.5))
void progress_send(int k)
{
	sprintf(label, "%2dk", k);
	status_complete = round(status_width*k/outfile_txt_size());
	draw_bar();
	wrefresh(progress);
}

void progress_receive(int k)
{
	sprintf(label, "%3dk", k);
	status_complete = round(status_width*k/340);
	draw_bar();
	wrefresh(progress);
}

void progress_done(float percent)
{
	sprintf(label, "%5.2f%%", percent);
	status_complete = round(status_width*percent/100.0);
	draw_bar();

	/* thrown in here cuz there isn't really anywhere else
	 * to put it... */
	machine_redraw();
	setiview_refresh(progress);
}

void progress_clear(void)
{
	wclear(progress);
	label[0]=0;
	wrefresh(progress);
}

