#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include "pty.h"

static FILE *ttyfp, *ptyfp;

static int find_tty(void)
{
	int i, j;
	int fd, fd2;
	char devname[128];

	strcpy(devname, "/dev/ptyXX");

	for(j='p'; j<='s'; j++) {
	    devname[8] = j;
	    for(i='0';i<='9';i++) {
		devname[9] = i;
		fd = open(devname, O_RDONLY);
		/* can we access pty device? */
		if(fd != -1) { 
		    /* can we access tty device? */
		    devname[5] = 't';
		    fd2 = open(devname, O_WRONLY);
		    if(fd2 != -1) { 
		    	ptyfp = fdopen(fd, "r");
			ttyfp = fdopen(fd2, "w");
		    	return 1; 
		    }
		    /* no, try more ptys */
		    devname[5] = 'p';
		    close(fd); 
		}
	    }
	}
	return 0;
}

FILE *pty_alloc(void)
{
	if(!find_tty()) {
		printf("Can't allocate pseudotty!\n");
		exit(0);
	}

	setlinebuf(ptyfp);
	return ptyfp;
}

void pty_fork(char **argv, int *pid)
{
	if(!(*pid = fork())) {
		dup2(fileno(ttyfp), fileno(stdout));
		execvp(argv[0], argv);
		exit(-1);
	}
}

void pty_close(void)
{
	fclose(ptyfp);
	fclose(ttyfp);
}

