#ifndef __SETIVIEW_H
#define __SETIVIEW_H

#if HAVE_NCURSES_H
#include <ncurses.h>
#else
#include <curses.h>
#endif

extern void seti_restart(void);

extern void setiview_init(void);
extern void setiview_end(void);
extern void setiview_redraw(void);

extern void setiview_error(void);

extern void setiview_refresh(WINDOW *win);
extern void waddstring(WINDOW *win, const char *string, chtype attr);

extern void user_info_init(void);
extern void user_info_redraw(void);
extern void user_info_login(const char *name);
extern void user_info_workunits(int units);
extern void user_info_cputime(int seconds);
extern void user_info_workunit_complete(void);

extern void analysis_redraw(void);
extern void analysis_status(const char *stat);
extern void analysis_drift(const char *drift);
extern void analysis_shift(const char *shift);
extern void analysis_fftlen(const char *length);

extern void data_info_redraw(void);
extern void data_info_put(int line, const char *info);

extern void progress_redraw(void);
extern void progress_send(int k);
extern void progress_receive(int k);
extern void progress_done(float percent);
extern void progress_clear(void);

extern void machine_redraw(void);
extern void machine_set_hostname(const char *name);

extern void misc_put(char c);
extern void misc_flush(void);

#endif

